
/******************************************************************************
* MODULE     : genalias.hh
* DESCRIPTION: generic aliases
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __GENALIAS_HH
#define __GENALIAS_HH
#include <generic.hh>
namespace mmx {

class genalias_rep: public generic_rep {
public:
  inline genalias_rep () {}
  inline virtual ~genalias_rep () {}

  virtual void Print (ostream& out);
  virtual bool Is_genalias ();

  virtual generic  get ();                   // get the value
  virtual void     set (generic val);        // set the value
  virtual generic& get_ref ();               // get the reference, if possible
  virtual void     set_caution (generic g);  // reference part of what?

  friend class table;
  friend class loctable;
};

class genalias {
DEFAULT_METHODS(genalias);
public:
  friend ostream& operator << (ostream& out, genalias a);
};

}
#endif // __GENALIAS_HH
