
/******************************************************************************
* MODULE     : conv_forall.cc
* DESCRIPTION: Template values as results of conversions
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

void
evaluator_rep::kw_conv_forall_1 () {
  CHECK_SYNC (CONV_FORALL);
  // INPUT: (conv_forall_1, cont, ...)
  list    qval= as_list (car (trace));
  generic val = list (MMX_FORALLVAL, env, cadr (qval), cadddr (qval));
  generic type= caddr (qval);
  cur= car (rem);
  rem= cons (value (val, type), cdr (rem));
  // OUTPUT: (cont, ret, ...)
  trace= cdr (trace);
}

} // namespace mmx
